package game;

import java.util.*;

/**
 * A directed edge on the map. Frozen, and hashable.
 */
public enum MapDirectedEdgeType {
	PLAIN(false,4,4,8,0.1d,0,"hallway"),PLAIN_(true,4,4,8,0.1d,0,""),
	WALL(true,0,0,0,0d,0,""),
	FIZZLE(false,0,0,4,1d,0,"fizzler"),FIZZLE_(true,0,0,4,1d,0,""),
	FIRE(false,4,4,0,1d,0,"laser field"),FIRE_(true,4,4,0,1d,0,""),
	GRID(false,0,4,0,0.9d,0,"grating"),GRID_(true,0,4,0,0.9d,0,""),
	WALL1(false,1,1,5,10d,1,"wall that opens when button '1' is pressed"),WALL1_(true,1,1,5,10d,1,""),
	WALL2(false,2,2,6,10d,2,"wall that opens when button '2' is pressed"),WALL2_(true,2,2,6,10d,2,""),
	WALL3(false,3,3,7,10d,3,"wall that opens when button '3' is pressed"),WALL3_(true,3,3,7,10d,3,""),
	FIZZLE1(false,1,1,1,10d,1,"fizzler that deactivates when button '1' is pressed"),FIZZLE1_(true,1,1,1,10d,1,""),
	FIZZLE2(false,2,2,2,10d,2,"fizzler that deactivates when button '2' is pressed"),FIZZLE2_(true,2,2,2,10d,2,""),
	FIZZLE3(false,3,3,3,10d,3,"fizzler that deactivates when button '3' is pressed"),FIZZLE3_(true,3,3,3,10d,3,""),
	FIRE1(false,4,4,5,10d,1,"laser field that deactivates when button '1' is pressed"),FIRE1_(true,4,4,5,10d,1,""),
	FIRE2(false,4,4,6,10d,2,"laser field that deactivates when button '2' is pressed"),FIRE2_(true,4,4,6,10d,2,""),
	FIRE3(false,4,4,7,10d,3,"laser field that deactivates when button '3' is pressed"),FIRE3_(true,4,4,7,10d,3,""),
	SPATH(false,4,0,8,0.2d,0,"twisted passage that does not allow one to see from one side to the other"),SPATH_(true,4,0,8,0.2d,0,""),
	HIGHSTAIRS(false,4,4,8,0.2d,0,"a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRS_(true,0,0,0,0.2d,0,""),
	JUMPPADOVERWATER(false,4,4,8,5d,0,"a sea with a jump pad in one direction"),JUMPPADOVERWATER_(true,0,4,0,5d,0,""),
	LIGHTBRIDGE1(false,1,4,5,15d,1,"a sea with a light bridge that activates as long button '1' is pressed"),LIGHTBRIDGE1_(true,1,4,5,15d,1,""),
	LIGHTBRIDGE2(false,2,4,6,15d,2,"a sea with a light bridge that activates as long button '2' is pressed"),LIGHTBRIDGE2_(true,2,4,6,15d,2,""),
	LIGHTBRIDGE3(false,3,4,7,15d,3,"a sea with a light bridge that activates as long button '3' is pressed"),LIGHTBRIDGE3_(true,3,4,7,15d,3,""),
	HIGHSTAIRSWITHFIZZLER(false,0,0,4,1.1d,0,"a fizzler on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIZZLER_(true,0,0,0,1.1d,0,""),
	HIGHSTAIRSWITHFIZZLER1(false,1,1,1,11d,1,"a fizzler (deactivated when button '1' is pressed) on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIZZLER1_(true,0,0,0,11d,0,""),
	HIGHSTAIRSWITHFIZZLER2(false,2,2,2,11d,2,"a fizzler (deactivated when button '2' is pressed) on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIZZLER2_(true,0,0,0,11d,0,""),
	HIGHSTAIRSWITHFIZZLER3(false,3,3,3,11d,3,"a fizzler (deactivated when button '3' is pressed) on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIZZLER3_(true,0,0,0,11d,0,""),
	HIGHSTAIRSWITHFIRE(false,4,4,0,1.1d,0,"a laser field on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIRE_(true,0,0,0,1.1d,0,""),
	HIGHSTAIRSWITHFIRE1(false,4,4,5,11d,1,"a laser field (deactivated when button '1' is pressed) on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIRE1_(true,0,0,0,11d,0,""),
	HIGHSTAIRSWITHFIRE2(false,4,4,6,11d,2,"a laser field (deactivated when button '2' is pressed) on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIRE2_(true,0,0,0,11d,0,""),
	HIGHSTAIRSWITHFIRE3(false,4,4,7,11d,3,"a laser field (deactivated when button '3' is pressed) on top of a high cliff that one can jump down but not climb up or throw cubes up"),HIGHSTAIRSWITHFIRE3_(true,0,0,0,11d,0,""),
	SHAFTWITHFIRE(false,4,0,0,1.2d,0,"a deep hole with a laser field in the middle"),SHAFTWITHFIRE_(true,0,0,0,1.2d,0,""),
	SHAFTWITHFIRE1(false,4,0,5,12d,1,"a deep hole with a laser field in the middle, which is deactivated when button '1' is pressed"),SHAFTWITHFIRE1_(true,0,0,0,12d,0,""),
	SHAFTWITHFIRE2(false,4,0,6,12d,2,"a deep hole with a laser field in the middle, which is deactivated when button '2' is pressed"),SHAFTWITHFIRE2_(true,0,0,0,12d,0,""),
	SHAFTWITHFIRE3(false,4,0,7,12d,3,"a deep hole with a laser field in the middle, which is deactivated when button '3' is pressed"),SHAFTWITHFIRE3_(true,0,0,0,12d,0,""),
	SHAFTWITHFIZZLER(false,0,0,4,1.2d,0,"a deep hole with a fizzler in the middle"),SHAFTWITHFIZZLER_(true,0,0,0,1.2d,0,""),
	SHAFTWITHFIZZLER1(false,1,0,1,12d,1,"a deep hole with a fizzler in the middle, which is deactivated when button '1' is pressed"),SHAFTWITHFIZZLER1_(true,0,0,0,12d,0,""),
	SHAFTWITHFIZZLER2(false,2,0,2,12d,2,"a deep hole with a fizzler in the middle, which is deactivated when button '2' is pressed"),SHAFTWITHFIZZLER2_(true,0,0,0,12d,0,""),
	SHAFTWITHFIZZLER3(false,3,0,3,12d,3,"a deep hole with a fizzler in the middle, which is deactivated when button '3' is pressed"),SHAFTWITHFIZZLER3_(true,0,0,0,12d,0,""),
	BLOCKINGLIGHTBRIDGE1(false,1,4,5,20d,1,"a lightbridge standing in the way, which is deactivated when button '1' is pressed"),BLOCKINGLIGHTBRIDGE1_(true,1,4,5,20d,1,""),
	BLOCKINGLIGHTBRIDGE2(false,2,4,6,20d,2,"a lightbridge standing in the way, which is deactivated when button '2' is pressed"),BLOCKINGLIGHTBRIDGE2_(true,2,4,6,20d,2,""),
	BLOCKINGLIGHTBRIDGE3(false,3,4,7,20d,3,"a lightbridge standing in the way, which is deactivated when button '3' is pressed"),BLOCKINGLIGHTBRIDGE3_(true,3,4,7,20d,3,""),
	HIGHSTAIRSWITHGRID(false,0,4,0,0.95d,0,"a grating on top of a high cliff so that one can only see in one direction"),HIGHSTAIRSWITHGRID_(true,0,0,0,0.95d,0,""),
	//ADJUST
	;
	private String humanReadable;
	private boolean isJustCompanion;
	private int canThrowCube;//0=no. 1,2,3=if button is pressed. 4=yes.
	private int canShoot;//0=no. 1,2,3=if button is pressed. 4=yes.
	private int canWalk;//0=no. 1,2,3=fizzles if button is not pressed. 4=fizzles. 5,6,7=free if button is pressed (otherwise blocked), 8=always free
	private double complexity;
	private int buttonInfluence;
	private MapDirectedEdgeType(boolean isJustCompanion, int canThrowCube, int canShoot, int canWalk, double complexity, int isInfluencedByButton, String humanReadable) {
		if (canThrowCube>4) throw new Error();
		if (canShoot>4) throw new Error();
		if (canWalk>8) throw new Error();
		this.isJustCompanion = isJustCompanion;
		this.canThrowCube = canThrowCube;
		this.canShoot = canShoot;
		this.canWalk = canWalk;
		this.complexity = complexity;
		this.buttonInfluence = isInfluencedByButton;
		this.humanReadable = humanReadable;
	}
	public String humanReadable() {
		return humanReadable;
	}
	public boolean isJustCompanion() {
		return isJustCompanion;
	}
	public double complexity() {
		if (isJustCompanion) return 0;
		return complexity;
	}
	public static int maxIndex() {
		return 41;//ADJUST
	}
	public static Vector<MapDirectedEdgeType> pair(int index) {
		Vector<MapDirectedEdgeType> ret = new Vector<MapDirectedEdgeType>();
		switch(index) {
		case  0: ret.add(PLAIN);ret.add(PLAIN_);break;
		case  1: ret.add(WALL);ret.add(WALL);break;
		case  2: ret.add(FIZZLE);ret.add(FIZZLE_);break;
		case  3: ret.add(FIRE);ret.add(FIRE_);break;
		case  4: ret.add(GRID);ret.add(GRID_);break;
		case  5: ret.add(WALL1);ret.add(WALL1_);break;
		case  6: ret.add(WALL2);ret.add(WALL2_);break;
		case  7: ret.add(WALL3);ret.add(WALL3_);break;
		case  8: ret.add(FIZZLE1);ret.add(FIZZLE1_);break;
		case  9: ret.add(FIZZLE2);ret.add(FIZZLE2_);break;
		case 10: ret.add(FIZZLE3);ret.add(FIZZLE3_);break;
		case 11: ret.add(FIRE1);ret.add(FIRE1_);break;
		case 12: ret.add(FIRE2);ret.add(FIRE2_);break;
		case 13: ret.add(FIRE3);ret.add(FIRE3_);break;
		case 14: ret.add(SPATH);ret.add(SPATH_);break;
		case 15: ret.add(HIGHSTAIRS);ret.add(HIGHSTAIRS_);break;
		case 16: ret.add(HIGHSTAIRS_);ret.add(HIGHSTAIRS);break;
		case 17: ret.add(JUMPPADOVERWATER);ret.add(JUMPPADOVERWATER_);break;
		case 18: ret.add(JUMPPADOVERWATER_);ret.add(JUMPPADOVERWATER);break;
		case 19: ret.add(LIGHTBRIDGE1);ret.add(LIGHTBRIDGE1_);break;
		case 20: ret.add(LIGHTBRIDGE2);ret.add(LIGHTBRIDGE2_);break;
		case 21: ret.add(LIGHTBRIDGE3);ret.add(LIGHTBRIDGE3_);break;
		case 22: ret.add(HIGHSTAIRSWITHFIZZLER);ret.add(HIGHSTAIRSWITHFIZZLER_);break;
		case 23: ret.add(HIGHSTAIRSWITHFIZZLER1);ret.add(HIGHSTAIRSWITHFIZZLER1_);break;
		case 24: ret.add(HIGHSTAIRSWITHFIZZLER2);ret.add(HIGHSTAIRSWITHFIZZLER2_);break;
		case 25: ret.add(HIGHSTAIRSWITHFIZZLER3);ret.add(HIGHSTAIRSWITHFIZZLER3_);break;
		case 26: ret.add(HIGHSTAIRSWITHFIRE);ret.add(HIGHSTAIRSWITHFIRE_);break;
		case 27: ret.add(HIGHSTAIRSWITHFIRE1);ret.add(HIGHSTAIRSWITHFIRE1_);break;
		case 28: ret.add(HIGHSTAIRSWITHFIRE2);ret.add(HIGHSTAIRSWITHFIRE2_);break;
		case 29: ret.add(HIGHSTAIRSWITHFIRE3);ret.add(HIGHSTAIRSWITHFIRE3_);break;
		case 30: ret.add(SHAFTWITHFIRE);ret.add(SHAFTWITHFIRE_);break;
		case 31: ret.add(SHAFTWITHFIRE1);ret.add(SHAFTWITHFIRE1_);break;
		case 32: ret.add(SHAFTWITHFIRE2);ret.add(SHAFTWITHFIRE2_);break;
		case 33: ret.add(SHAFTWITHFIRE3);ret.add(SHAFTWITHFIRE3_);break;
		case 34: ret.add(SHAFTWITHFIZZLER);ret.add(SHAFTWITHFIZZLER_);break;
		case 35: ret.add(SHAFTWITHFIZZLER1);ret.add(SHAFTWITHFIZZLER1_);break;
		case 36: ret.add(SHAFTWITHFIZZLER2);ret.add(SHAFTWITHFIZZLER2_);break;
		case 37: ret.add(SHAFTWITHFIZZLER3);ret.add(SHAFTWITHFIZZLER3_);break;
		case 38: ret.add(BLOCKINGLIGHTBRIDGE1);ret.add(BLOCKINGLIGHTBRIDGE1_);break;
		case 39: ret.add(BLOCKINGLIGHTBRIDGE2);ret.add(BLOCKINGLIGHTBRIDGE2_);break;
		case 40: ret.add(BLOCKINGLIGHTBRIDGE3);ret.add(BLOCKINGLIGHTBRIDGE3_);break;
		case 41: ret.add(HIGHSTAIRSWITHGRID);ret.add(HIGHSTAIRSWITHGRID_);break;
		//ADJUST
		}
		if (ret.get(0).complexity!=ret.get(1).complexity) throw new Error();
		return ret;
	}
	public static Vector<MapDirectedEdgeType> randomPair() {
		int rand = Rand.rand.nextInt(maxIndex()+1);
		return pair(rand);
	}
	public boolean canThrowCube(boolean button1, boolean button2, boolean button3) {
		if (canThrowCube==4) return true;
		if (canThrowCube==1 && button1) return true;
		if (canThrowCube==2 && button2) return true;
		if (canThrowCube==3 && button3) return true;
		return false;
	}
	public boolean canShoot(boolean button1, boolean button2, boolean button3) {
		if (canShoot==4) return true;
		if (canShoot==1 && button1) return true;
		if (canShoot==2 && button2) return true;
		if (canShoot==3 && button3) return true;
		return false;
	}
	/**
	 * 0=no
	 * 1=fizzles
	 * 2=yes
	 */
	public int canWalk(boolean button1, boolean button2, boolean button3) {
		if (canWalk==8) return 2;
		if (canWalk==5 && button1) return 2;
		if (canWalk==6 && button2) return 2;
		if (canWalk==7 && button3) return 2;
		if (canWalk==4) return 1;
		if (canWalk==1 && button1) return 2;
		if (canWalk==2 && button2) return 2;
		if (canWalk==3 && button3) return 2;
		if (canWalk==1 && !button1) return 1;
		if (canWalk==2 && !button2) return 1;
		if (canWalk==3 && !button3) return 1;
		return 0;
	}
	public int buttonInfluence() {
		return buttonInfluence;
	}
}
