package game;

import java.util.*;

/**
 * frozen and hashable
 */
public class MapVertex {
	private int portalability=0;//0,1,2
	private boolean cubedropper1=false;
	private boolean cubedropper2=false;
	private boolean cubespawnbutton1=false;
	private boolean cubespawnbutton2=false;
	private boolean button1=false;
	private boolean button2=false;
	private boolean button3=false;
	public double complexity() {
		double ret = 0;
		if (portalability==1) ret+=0.1;
		if (portalability==0) ret+=0.01;
		if (button1) ret+=0.2;
		if (button2) ret+=0.2;
		if (button3) ret+=0.2;
		return ret;
	}
	public MapVertex() {
		portalability=Rand.rand.nextInt(3);
		if (Rand.rand.nextInt(20)==0) cubedropper1=true;
		if (Rand.rand.nextInt(20)==0) cubedropper2=true;
		if (Rand.rand.nextInt(20)==0) cubespawnbutton1=true;
		if (Rand.rand.nextInt(20)==0) cubespawnbutton2=true;
		if (Rand.rand.nextInt(20)==0) button1=true;
		if (Rand.rand.nextInt(20)==0) button2=true;
		if (Rand.rand.nextInt(20)==0) button3=true;
	}
	private void legalize() {
		if ((button1 || button2 || button3)&&(cubedropper1 || cubedropper2)) {
			button1=false;button2=false;button3=false;
		}
		if (portalability==1 && (button1 || button2 || button3)) portalability=Rand.rand.nextBoolean()?0:2;
	}
	public MapVertex(MapVertex copy) {
		portalability=copy.portalability;
		cubedropper1=copy.cubedropper1;
		cubedropper2=copy.cubedropper2;
		cubespawnbutton1=copy.cubespawnbutton1;
		cubespawnbutton2=copy.cubespawnbutton2;
		button1=copy.button1;
		button2=copy.button2;
		button3=copy.button3;
	}
	public MapVertex(String s) {
		portalability=new Integer(s.substring(0,1));
		cubedropper1=t(s.substring(1,2));
		cubedropper2=t(s.substring(2,3));
		cubespawnbutton1=t(s.substring(3,4));
		cubespawnbutton2=t(s.substring(4,5));
		button1=t(s.substring(5,6));
		button2=t(s.substring(6,7));
		button3=t(s.substring(7,8));
		legalize();
	}
	private static Vector<MapVertex> allpossibilities = null;
	private static void generateAllPossibilities() {
		allpossibilities=new Vector<MapVertex>();
		for (int portalability=0;portalability<=2;portalability++) {
//			for (int cubedropper1=0;cubedropper1<=1;cubedropper1++) {
//				for (int cubedropper2=0;cubedropper2<=1;cubedropper2++) {
//					for (int cubespawnbutton1=0;cubespawnbutton1<=1;cubespawnbutton1++) {
//						for (int cubespawnbutton2=0;cubespawnbutton2<=1;cubespawnbutton2++) {
							for (int button1=0;button1<=1;button1++) {
								for (int button2=0;button2<=1;button2++) {
									for (int button3=0;button3<=1;button3++) {
//										allpossibilities.add(new MapVertex(""+portalability+""+cubedropper1+""+cubedropper2+""+cubespawnbutton1+""+cubespawnbutton2+""+button1+""+button2+""+button3));
										allpossibilities.add(new MapVertex(""+portalability+""+"0"+""+"0"+""+"0"+""+"0"+""+button1+""+button2+""+button3));
									}
								}
							}
//						}
//					}
//				}
//			}	
		}
	}
	public static MapVertex getPossibility(int index) {
		if (allpossibilities==null) {
			generateAllPossibilities();
		}
		return allpossibilities.get(index);
	}
	public static int getNumberOfPossibilities() {
		if (allpossibilities==null) {
			generateAllPossibilities();
		}
		return allpossibilities.size();
	}
	private String s(boolean b) {
		return b?"1":"0";
	}
	private boolean t(String c) {
		return c.equals("0")?false:true;
	}
	@Override
	public String toString() {
		String ret = "";
		ret+=portalability;
		ret+=s(cubedropper1);
		ret+=s(cubedropper2);
		ret+=s(cubespawnbutton1);
		ret+=s(cubespawnbutton2);
		ret+=s(button1);
		ret+=s(button2);
		ret+=s(button3);
		return ret;
	}
	public String humanReadable(int i) {
		String ret = "[";
		if (i==0) ret+="[starting location]";
		if (i==1) ret+="[exit location with a door sealed by two cube buttons]";
		if (portalability==1) ret+="[portal surface on ceiling]";
		if (portalability==2) ret+="[portal surface on wall]";
		if (cubedropper1) ret+="[storage cube dropper]";
		if (cubedropper2) ret+="[companion cube dropper]";
		if (cubespawnbutton1) ret+="[button to spawn storage cube]";
		if (cubespawnbutton2) ret+="[button to spawn companion cube]";
		if (button1) ret+="[cube button that activates things with label '1']";
		if (button2) ret+="[cube button that activates things with label '2']";
		if (button3) ret+="[cube button that activates things with label '3']";
		ret+="]";
		return ret;
	}
	public MapVertex setItem(Item item, boolean value) {
		MapVertex ret = new MapVertex(this);
		if (item==Item.CUBEDROPPER1) ret.cubedropper1=value;
		if (item==Item.CUBEDROPPER2) ret.cubedropper2=value;
		if (item==Item.CUBESPAWNBUTTON1) ret.cubespawnbutton1=value;
		if (item==Item.CUBESPAWNBUTTON2) ret.cubespawnbutton2=value;
		if (item==Item.BUTTON1) ret.button1=value;
		if (item==Item.BUTTON2) ret.button2=value;
		if (item==Item.BUTTON3) ret.button3=value;
		ret.legalize();
		return ret;
	}
	public boolean hasItem(Item item) {
		if (item==Item.CUBEDROPPER1) return cubedropper1;
		if (item==Item.CUBEDROPPER2) return cubedropper2;
		if (item==Item.CUBESPAWNBUTTON1) return cubespawnbutton1;
		if (item==Item.CUBESPAWNBUTTON2) return cubespawnbutton2;
		if (item==Item.BUTTON1) return button1;
		if (item==Item.BUTTON2) return button2;
		if (item==Item.BUTTON3) return button3;
		throw new Error();
	}
	public MapVertex setPortalability(int value) {
		MapVertex ret = new MapVertex(this);
		ret.portalability=value;
		ret.legalize();
		return ret;
	}
	public boolean isButton(int i) {//i=1,2,3
		if (i==1) return button1;
		if (i==2) return button2;
		if (i==3) return button3;
		throw new Error();
	}
	public boolean isCubeSpawnButton(int i) {//i=1,2
		if (i==1) return cubespawnbutton1;
		if (i==2) return cubespawnbutton2;
		throw new Error();
	}
	public boolean isCubeDropper(int i) {//i=1,2
		if (i==1) return cubedropper1;
		if (i==2) return cubedropper2;
		throw new Error();
	}
	public boolean isPortalable() {
		return portalability>=1;
	}
	public boolean isPortalAccessible() {
		return portalability>=2;
	}
	@Override
	public int hashCode() {
		return (button3?1:0)+(button2?2:0)+(button1?4:0)+(cubespawnbutton2?8:0)+(cubespawnbutton1?16:0)+(cubedropper2?32:0)+(cubedropper1?64:0)+portalability*128;
	}
	@Override
	public boolean equals(Object o) {
		if (o instanceof MapVertex) {
			MapVertex v = (MapVertex)o;
			return portalability==v.portalability && cubedropper1==v.cubedropper1 && cubedropper2==v.cubedropper2 && cubespawnbutton1==v.cubespawnbutton1 && cubespawnbutton2==v.cubespawnbutton2 && button1==v.button1 && button2==v.button2 && button3==v.button3;
		}
		return false;
	}
}

